<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>Task 48.40</title>

    <!-- Google Font: Source Sans Pro -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback"
    />
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  </head>
  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"
              ><i class="fas fa-bars"></i
            ></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">Home</a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">User</a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img
            src="dist/img/AdminLTELogo.png"
            alt="AdminLTE Logo"
            class="brand-image img-circle elevation-3"
            style="opacity: 0.8;"
          />
          <span class="brand-text font-weight-light">DEVCAMP</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/user2-160x160.jpg"
                class="img-circle elevation-2"
                alt="User Image"
              />
            </div>
            <div class="info">
              <a href="#" class="d-block">Le Nguyen</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Dashboard
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                <ul class="nav nav-treeview">
                  <li class="nav-item">
                    <a href="#" class="nav-link active">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Home</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="#" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>User</p>
                    </a>
                  </li>
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1>F120 - Quản trị Users</h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">User</li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <section class="content">
          <!-- Default box -->
          <div class="card">
            <div class="container">
              <div class="form-group mt-3">
                <button class="btn btn-success" id="btn-add-user">
                  <i class="fa fa-plus"></i>&nbsp; New User
                </button>
              </div>
            </div>

            <div class="container">
              <table
                class="table table-bordered table-striped table-hover"
                id="user-table"
              >
                <thead>
                  <th>Id</th>
                  <th>Firstname</th>
                  <th>Lastname</th>
                  <th>Country</th>
                  <th>Subject</th>
                  <th>Customer Type</th>
                  <th>Register Status</th>
                  <th>Action</th>
                </thead>
              </table>
            </div>

            <!-- User modal -->
            <div id="create-user-modal" class="modal fade" tabindex="-1">
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-tittle" id="h5-modal-tittle">
                      Create new user
                    </h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                    <form action="">
                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="input-create-firstname"
                          >Firstname</label
                        >
                        <div class="col-sm-8">
                          <input
                            type="text"
                            id="input-create-firstname"
                            placeholder="Firstname"
                            class="form-control"
                          />
                        </div>
                      </div>

                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="input-create-lastname"
                          >Lastname</label
                        >
                        <div class="col-sm-8">
                          <input
                            type="text"
                            id="input-create-lastname"
                            placeholder="Lastname"
                            class="form-control"
                          />
                        </div>
                      </div>

                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="select-create-country"
                          >Country</label
                        >
                        <div class="col-sm-8">
                          <select
                            id="select-create-country"
                            class="form-control"
                          >
                            <option value="VN">Việt Nam</option>
                            <option value="USA">USA</option>
                            <option value="AUS">Australia</option>
                            <option value="CAN">Canada</option>
                          </select>
                        </div>
                      </div>

                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="select-create-customer-type"
                          >Customer Type</label
                        >
                        <div class="col-sm-8">
                          <select
                            id="select-create-customer-type"
                            class="form-control"
                          >
                            <option value="Standard">Standard</option>
                            <option value="Gold">Gold</option>
                            <option value="Premium">Premium</option>
                          </select>
                        </div>
                      </div>

                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="input-create-subject"
                          >Subject</label
                        >
                        <div class="col-sm-8">
                          <input
                            type="text"
                            id="input-create-subject"
                            placeholder="Subject"
                            class="form-control"
                          />
                        </div>
                      </div>
                    </form>
                  </div>
                  <div class="modal-footer">
                    <button class="btn btn-primary" id="btn-create-user">
                      Insert User
                    </button>
                    <button
                      class="btn btn-secondary"
                      id="btn-create-cancel"
                      data-dismiss="modal"
                    >
                      Cancel
                    </button>
                  </div>
                </div>
              </div>
            </div>

            <!-- Modal update -->
            <div id="update-user-modal" class="modal fade" tabindex="-1">
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-tittle" id="h5-modal-tittle">
                      Chi tiết user
                    </h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                    <form action="">
                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="input-update-firstname"
                          >Firstname</label
                        >
                        <div class="col-sm-8">
                          <input
                            type="text"
                            id="input-update-firstname"
                            placeholder="Firstname"
                            class="form-control"
                          />
                        </div>
                      </div>

                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="input-update-lastname"
                          >Lastname</label
                        >
                        <div class="col-sm-8">
                          <input
                            type="text"
                            id="input-update-lastname"
                            placeholder="Lastname"
                            class="form-control"
                          />
                        </div>
                      </div>
                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="input-update-subject"
                          >Subject</label
                        >
                        <div class="col-sm-8">
                          <input
                            type="text"
                            id="input-update-subject"
                            placeholder="Subject"
                            class="form-control"
                          />
                        </div>
                      </div>

                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="select-update-country"
                          >Country</label
                        >
                        <div class="col-sm-8">
                          <select
                            id="select-update-country"
                            class="form-control"
                          >
                            <option value="VN">Việt Nam</option>
                            <option value="USA">USA</option>
                            <option value="AUS">Australia</option>
                            <option value="CAN">Canada</option>
                          </select>
                        </div>
                      </div>

                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="select-update-customer-type"
                          >Customer Type</label
                        >
                        <div class="col-sm-8">
                          <select
                            id="select-update-customer-type"
                            class="form-control"
                          >
                            <option value="Standard">Standard</option>
                            <option value="Gold">Gold</option>
                            <option value="Premium">Premium</option>
                          </select>
                        </div>
                      </div>

                      <div class="row form-group">
                        <label
                          class="col-form-label col-sm-4"
                          for="select-update-register-status"
                          >Register Status</label
                        >
                        <div class="col-sm-8">
                          <select
                            id="select-update-register-status"
                            class="form-control"
                          >
                            <option value="New">New</option>
                            <option value="Accepted">Accepted</option>
                            <option value="Denied">Denied</option>
                          </select>
                        </div>
                      </div>
                    </form>
                  </div>
                  <div class="modal-footer">
                    <button class="btn btn-primary" id="btn-update-user">
                      Update User
                    </button>
                    <button
                      class="btn btn-secondary"
                      id="btn-update-cancel"
                      data-dismiss="modal"
                    >
                      Hủy bỏ
                    </button>
                  </div>
                </div>
              </div>
            </div>

            <!-- Delete confirm modal -->
            <div>
              <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                <div class="modal-dialog">
                  <div class="modal-content">
                    <div class="modal-header">
                      <h5 class="modal-title" id="h5-modal-title">
                        Confirm xóa user
                      </h5>
                      <button class="close" data-dismiss="modal">
                        &times;
                      </button>
                    </div>
                    <div class="modal-body">
                      <label>Bạn có chắc chắn muốn xóa user này không?</label>
                    </div>
                    <div class="modal-footer">
                      <button
                        class="btn btn-danger"
                        id="btn-confirm-delete-user"
                      >
                        Xác nhận
                      </button>
                      <button class="btn btn-secondary" data-dismiss="modal">
                        Hủy bỏ
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- /.card -->
        </section>
        <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block"><b>Version</b> 1.0.0</div>
        <strong>Copyright &copy; 2023 <a href="#">Devcamp</a>.</strong> All
        rights reserved.
      </footer>
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>

    <!-- Data Table-->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </body>
</html>

<script>
  "use strict";
  $(document).ready(function () {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

    var gUserId = 0;

    const gUSER_COLS = [
      "id",
      "firstname",
      "lastname",
      "country",
      "subject",
      "customerType",
      "registerStatus",
      "action",
    ];
    const gUSER_ID = 0;
    const gFIRST_NAME = 1;
    const gLAST_NAME = 2;
    const gCOUNTRY = 3;
    const gSUBJECT = 4;
    const gCUSTOMER_TYPE = 5;
    const gREGISTER_STATUS = 6;
    const gACTION = 7;

    var gUserTable = $("#user-table").DataTable({
      columns: [
        { data: gUSER_COLS[gUSER_ID] },
        { data: gUSER_COLS[gFIRST_NAME] },
        { data: gUSER_COLS[gLAST_NAME] },
        { data: gUSER_COLS[gCOUNTRY] },
        { data: gUSER_COLS[gSUBJECT] },
        { data: gUSER_COLS[gCUSTOMER_TYPE] },
        { data: gUSER_COLS[gREGISTER_STATUS] },
        { data: gUSER_COLS[gACTION] },
      ],
      columnDefs: [
        {
          targets: gACTION,
          defaultContent: `
                    <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                    `,
        },
      ],
    });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    $(document).on("click", ".edit-user", function () {
      onBtnEditClick(this);
    });
    $(document).on("click", ".delete-user", function () {
      onBtnDeleteClick(this);
    });

    $("#btn-add-user").on("click", function () {
      onBtnAddUserClick();
    });
    //nút Insert User trên modal
    $("#btn-create-user").on("click", function () {
      onBtnCreateUserClick();
    });
    //nút Update User trên modal
    $("#btn-update-user").on("click", function () {
      onBtnUpdateUserClick();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm được gọi khi load trang
    function onPageLoading() {
      getAllUsers();
    }

    //hàm xử lý sự kiện bấm nút Sửa
    function onBtnEditClick(paramElement) {
      var vRowClick = $(paramElement).parents("tr");
      var vDataRow = gUserTable.row(vRowClick).data();
      gUserId = vDataRow.id;
      console.log(gUserId);

      $("#update-user-modal").modal("show");
      $("#input-update-firstname").val(vDataRow.firstname);
      $("#input-update-lastname").val(vDataRow.lastname);
      $("#input-update-subject").val(vDataRow.subject);
      $("#select-update-country").val(vDataRow.country);
      $("#select-update-customer-type").val(vDataRow.customerType);
      $("#select-update-register-status").val(vDataRow.registerStatus);
    }

    //hàm xử lý sự kiện bấm nút Delete
    function onBtnDeleteClick(paramElement) {
      var vRowClick = $(paramElement).parents("tr");
      var vDataRow = gUserTable.row(vRowClick).data();
      gUserId = vDataRow.id;
      console.log(gUserId);

      $("#delete-confirm-modal").modal("show");

      $(document).on("click", "#btn-confirm-delete-user", function () {
        $.ajax({
          url: gBASE_URL + gUserId,
          type: "DELETE",
          success: function (paramVouchers) {
            alert("Xóa thành công");
            getAllUsers();
            $("#delete-confirm-modal").modal("hide");
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      });
    }

    //hàm được gọi khi nút New User được ấn
    function onBtnAddUserClick() {
      $("#create-user-modal").modal("show");
    }

    // hàm xử lý sự kiện create user modal click
    function onBtnCreateUserClick() {
      var vUserObj = {
        firstname: "",
        lastname: "",
        country: "",
        customerType: "",
        subject: "",
      };
      // B1: Thu thập dữ liệu
      getCreateUserData(vUserObj);
      // B2: Validate insert
      var vIsUserValidate = validateUserData(vUserObj);
      if (vIsUserValidate) {
        // B3: insert user
        $.ajax({
          url: gBASE_URL,
          type: "POST",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(vUserObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertUserSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    }

    //hàm thực thi khi nhấn nút Update User trên modal
    function onBtnUpdateUserClick() {
      var vUserObj = {
        firstname: "",
        lastname: "",
        subject: "",
        country: "",
        customerType: "",
        registerStatus: "",
      };
      // B1: Thu thập dữ liệu
      getUpdateUserData(vUserObj);
      // B2: Validate dữ liệu
      var vIsUserValidate = validateUpdateUserData(vUserObj);
      if (vIsUserValidate) {
        // B3: update user
        $.ajax({
          url: gBASE_URL + gUserId,
          type: "PUT",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(vUserObj),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleUpdateUserSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm gọi api để lấy dữ liệu all users
    function getAllUsers() {
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        success: function (res) {
          console.log(res);
          loadDataToTable(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        },
      });
    }

    //hàm load dữ liệu vào table
    function loadDataToTable(paramObjectUsers) {
      gUserTable.clear();
      gUserTable.rows.add(paramObjectUsers);
      gUserTable.draw();
    }

    // hàm thu thập dữ liệu để create user
    function getCreateUserData(paramUserObj) {
      paramUserObj.firstname = $("#input-create-firstname").val().trim();
      paramUserObj.lastname = $("#input-create-lastname").val().trim();
      paramUserObj.country = $("#select-create-country").val();
      paramUserObj.customerType = $("#select-create-customer-type").val();
      paramUserObj.subject = $("#input-create-subject").val().trim();
    }

    // hàm validate data user
    function validateUserData(paramVoucherObj) {
      if (paramVoucherObj.firstname === "") {
        alert("Firstname cần nhập");
        return false;
      }

      if (paramVoucherObj.lastname === "") {
        alert("Lastname cần nhập");
        return false;
      }

      if (paramVoucherObj.subject === "") {
        alert("Subject cần nhập");
        return false;
      }

      return true;
    }

    // hàm xử lý hiển thị front-end khi thêm user thành công
    function handleInsertUserSuccess() {
      alert("Thêm user thành công!");
      getAllUsers();
      resertCreateUserForm();
      $("#create-user-modal").modal("hide");
    }

    // hàm xóa trắng form create user
    function resertCreateUserForm() {
      $("#input-create-firstname").val("");
      $("#input-create-lastname").val("");
      $("#select-create-country").val("VN");
      $("#select-create-customer-type").val("Standard");
      $("#input-create-subject").val("");
    }

    //hàm thu thập dữ liệu user update
    function getUpdateUserData(paramUserObj) {
      paramUserObj.firstname = $("#input-update-firstname").val().trim();
      paramUserObj.lastname = $("#input-update-lastname").val().trim();
      paramUserObj.subject = $("#input-update-subject").val().trim();
      paramUserObj.country = $("#select-update-country").val();
      paramUserObj.customerType = $("#select-update-customer-type").val();
      paramUserObj.registerStatus = $("#select-update-register-status").val();
    }

    // hàm validate data user update
    function validateUpdateUserData(paramUserObj) {
      if (paramUserObj.firstname === "") {
        alert("Firstname cần nhập");
        return false;
      }

      if (paramUserObj.lastname === "") {
        alert("Lastname cần nhập");
        return false;
      }

      return true;
    }

    // hàm xử lý hiển thị front-end khi sửa user thành công
    function handleUpdateUserSuccess() {
      alert("Sửa user thành công!");
      getAllUsers();
      resertUpdateUserForm();
      $("#update-user-modal").modal("hide");
    }

    // hàm xóa trắng form update user
    function resertUpdateUserForm() {
      $("#input-update-firstname").val("");
      $("#input-update-lastname").val("");
      $("#input-update-subject").val("");
      $("#select-update-country").val("VN");
      $("#select-update-customer-type").val("Standard");
      $("#select-update-register-status").val("New");
    }
  });
</script>
